#include <math.h>
__inline void DessPix(register int x,register int y,register int c)		{
	register unsigned char *ptr;
	x+=CLIP_X0;
	y+=CLIP_Y0;
	if (x<0 || y<0 || x>=CLIP_X1 || y>=CLIP_Y1)
		return;
	ptr=Bits+LARG_BUF*3*(HAUT_BUF-y)-3*(LARG_BUF-x);
	if ((c&0x0000ff)==0xfe)
		return;
	*(ptr++)=(unsigned char)((c&0x00ff0000)>>16);
	*(ptr++)=(unsigned char)((c&0x0000ff00)>>8);
	*(ptr++)=(unsigned char)(c&0x000000ff);
}

__inline void DessPixSansMasque(register int x,register int y,register int c)		{
	register unsigned char *ptr;
	x+=CLIP_X0;
	y+=CLIP_Y0;
	if (x<0 || y<0 || x>=CLIP_X1 || y>=CLIP_Y1)
		return;
	ptr=Bits+LARG_BUF*3*(HAUT_BUF-y)-3*(LARG_BUF-x);
	*(ptr++)=(unsigned char)((c&0x00ff0000)>>16);
	*(ptr++)=(unsigned char)((c&0x0000ff00)>>8);
	*(ptr++)=(unsigned char)(c&0x000000ff);
}

//Dessine un pixel invers avec la possibilit d'utiliser une couleur de masque
__inline void DessPixInvMasque(register int x,register int y,register int c)		{
	register unsigned char *ptr;
	x+=CLIP_X0;
	y+=CLIP_Y0;
	ptr=Bits+LARG_BUF*3*(HAUT_BUF-y)-3*(LARG_BUF-x);
	if ((c&0x0000ff)==0xfe)
		return;
	*(ptr++)=(unsigned char)(c&0x000000ff);
	*(ptr++)=(unsigned char)((c&0x0000ff00)>>8);
	*(ptr++)=(unsigned char)((c&0x00ff0000)>>16);
}

//TRS DANGEREUSE COMME ROUTINE MAIS 1.5 FOIS PLUS RAPIDE QUE DESSPIX.
#define FastDrawPix(x,y,c)		{			\
		unsigned char *__ptr=Bits+LARG_BUF*3*(HAUT_BUF-y)-3*(LARG_BUF-x);		\
		*(__ptr++)=(unsigned char)((c&0x00ff0000)>>16);							\
		*(__ptr++)=(unsigned char)((c&0x0000ff00)>>8);							\
		*(__ptr++)=(unsigned char)(c&0x000000ff);								\
}

//Dessine un pixel en mode invers (retourn par SpriteGetPix)
#define FastDrawInvPix(x,y,c)		{			\
		unsigned char *__ptr=Bits+LARG_BUF*3*(HAUT_BUF-y)-3*(LARG_BUF-x);		\
		*(__ptr++)=(unsigned char)(c&0x000000ff);								\
		*(__ptr++)=(unsigned char)((c&0x0000ff00)>>8);							\
		*(__ptr++)=(unsigned char)((c&0x00ff0000)>>16);							\
}

#define SpriteGetPix(sprite,x,y,l)		\
	((*(unsigned long *)((unsigned char*)sprite+l*3*y+3*x)))


/*A REGARDER:
	centrex=posX+cX; 
	centrey=posY+cY; 
	dmax=max(dimX+dimY-2,0); 
	xmin=max(centrex-dmax,0); 
	xmax=min(centrex+dmax,239); 
	ymin=max(centrey-dmax,0); 
	ymax=min(centrey+dmax,127);
*/
void Rotation(OBJET *obj, int x1, int y1, double t)		{
	int x, y, l=obj->largeur, h=obj->hauteur, centrex,centrey,dmax, min_x,max_x,min_y,max_y;
	double cosT,sinT, xp, yp, x1p=l/2, y1p=h/2;
    cosT = cos(t);
    sinT = sin(t);

	centrex=x1;
	centrey=y1;
	dmax=max(l+h-2,0);
	min_x=max(centrex-dmax,0);
	max_x=min(centrex+dmax,LARG);
	min_y=max(centrey-dmax,0);
	max_y=min(centrey+dmax,HAUT);

	for (y=min_y;y<max_y;y++)		{
			xp = (min_x-x1) * cosT + (y-y1) * sinT + x1p + 0.25;
			yp = (y-y1) * cosT - (min_x-x1) * sinT + y1p + 0.25;
			for (x = min_x; x <= max_x; x++)
            {
//				printf("%f %f ",xp,yp);
//				Getch();
				if (xp>=0 && xp<l && yp>=0 && yp<h)
					DessPixInvMasque(x,y,SpriteGetPix(obj->sprite,(int)xp,(int)yp,obj->largeur));
				xp += cosT;
				yp -= sinT;
            }
	}
}

void Redimensionne(OBJET *obj, int x0, int y0, int l, int h)		{
	int x, y, a=0;
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr, *spr=obj->sprite, *sprite, *spr2;
	int hb=obj->hauteur, lb=obj->largeur, y_min, x_min, y_max, x_max;

//	ClipSprite;

	int x1=x0+l, y1=y0+h;

	if (x0>=0)			x_min=x0;
	else				x_min=0;
	if (y0>=0)			y_min=y0;
	else				y_min=0;
	if (x1<LARG)		x_max=x1;
	else				x_max=LARG-1;
	if (y1<HAUT)		y_max=y1;
	else				y_max=HAUT-1;

	for (y=y_min;y<y_max;y++)	{
		ptr=bits-LARG_BUF*3*(y)-3*(LARG_BUF-x_min);
		spr2=spr+lb*3*((hb*(y-y0))/h);
		for (x=x_min;x<x_max;x++)	{
			sprite=spr2+3*((lb*(x-x0))/l);
			if (*sprite==0xfe)		{
				sprite+=3;
				ptr+=3;
				continue;
			}
			*ptr=*sprite++;
			ptr++;
			*ptr=*sprite++;
			ptr++;
			*ptr=*sprite++;
			ptr++;
		}
		sprite+=a;
	}

}

void RotoPiste(OBJET *obj, int x1, int y1, double x1p, double y1p, double facteur, double t)		{
	int centrex,centrey,dmax, min_x,max_x,min_y,max_y;
	register int x, y, l=obj->largeur, h=obj->hauteur;
	register double cosTf,sinTf, xp, yp;
	double fact, cosT, sinT;
	int taille;
	register unsigned char *sprite=obj->sprite;
	register unsigned int lr=obj->largeur;
    cosT = cos(t)/facteur;
    sinT = sin(t)/facteur;

	centrex=x1;
	centrey=y1;
	dmax=(int)((float)(max(l+l/10,h+h/10)/2)*(float)facteur);
	min_x=max(centrex-dmax,0);
	max_x=min(centrex+dmax,CLIP_X1-CLIP_X0-1);
	min_y=max(centrey-dmax,0);
	max_y=min(centrey+dmax,CLIP_Y1-CLIP_Y0-1);
//	AdditionneCadre(min_x,min_y,max_x-min_x,max_y-min_y,RGB(0,0,128));

//	taille=max_y-min_y+20;				//Pour modifier le point de fuite
	taille=max_y-min_y;
	for (y=min_y;y<max_y;y++)		{
//			fact=1.0/((float)((y-min_y+20)/(float)taille));
			fact=1.0/((float)((y-min_y)/(float)taille));
			if (fact==0.0)
				continue;
			cosTf=cosT*fact;
			sinTf=sinT*fact;
			xp = (min_x-x1) * cosTf + (y-y1) * sinTf + x1p + 0.25;
			yp = (y-y1) * cosTf - (min_x-x1) * sinTf + y1p + 0.25;
			for (x = min_x; x <= max_x; x++)
            {
//				printf("%f %f ",xp,yp);
//				Getch();
				if (xp>=0 && xp<l && yp>=0 && yp<h)
					DessPixInvMasque(x,y,SpriteGetPix(sprite,(int)xp,(int)yp,lr));
				xp += cosTf;
				yp -= sinTf;
            }
	}
}

void Rotozoom(OBJET *obj, int x1, int y1, double facteur, double t)		{
	int x, y, l=obj->largeur, h=obj->hauteur, centrex,centrey,dmax, min_x,max_x,min_y,max_y;
	double cosT,sinT, xp, yp, x1p=l/2, y1p=h/2;
    cosT = cos(t)/facteur;
    sinT = sin(t)/facteur;

	centrex=x1;
	centrey=y1;
	dmax=(int)((float)(max(l+l/10,h+h/10)/2)*(float)facteur);
	min_x=max(centrex-dmax,0);
	max_x=min(centrex+dmax,CLIP_X1-CLIP_X0-1);
	min_y=max(centrey-dmax,0);
	max_y=min(centrey+dmax,CLIP_Y1-CLIP_Y0-1);
//	AdditionneCadre(min_x,min_y,max_x-min_x,max_y-min_y,RGB(0,0,128));

	for (y=min_y;y<max_y;y++)		{
			xp = (min_x-x1) * cosT + (y-y1) * sinT + x1p + 0.25;
			yp = (y-y1) * cosT - (min_x-x1) * sinT + y1p + 0.25;
			for (x = min_x; x <= max_x; x++)
            {
//				printf("%f %f ",xp,yp);
//				Getch();
				if (xp>=0 && xp<l && yp>=0 && yp<h)
					DessPixInvMasque(x,y,SpriteGetPix(obj->sprite,(int)xp,(int)yp,obj->largeur));
				xp += cosT;
				yp -= sinT;
            }
	}
}
