typedef unsigned char * SPRITE;

#define ClipSprite			{										\
							if (!Bits || !sprite)	return;						\
							if (y0<0)	{							\
								sprite+=l*(0-y0)*3;					\
								h-=0-y0;							\
								y0=0;								\
							}										\
							if (x0<0)	{							\
								l+=0+x0;							\
								a=-x0;								\
								sprite+=-x0*3;						\
								x0=0;								\
							}										\
							y0+=CLIP_Y0;							\
							x0+=CLIP_X0;							\
							if (y0+h>=CLIP_Y1)	{					\
								h+=CLIP_Y1-(y0+h);					\
							}										\
							if (x0+l>=CLIP_X1)	{					\
								a=-(CLIP_X1-(x0+l));				\
								l-=a;								\
							}										\
							a*=3;									\
							if (h<0)	return;						\
							}


//Mouais... rapide entre guillemets quoi! Elle limine la fonction de pixels transparents et copie plus rapidement
void SpriteRapide(int x0, int y0, int l, int h, register unsigned char *sprite)		{
	int x, y, a=0;
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr, tmp;

	ClipSprite;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			tmp=*(ptr+3);
			*(long*)ptr=*(long*)sprite;
			ptr+=3;
			sprite+=3;
		}
		*(ptr)=tmp;
		sprite+=a;
	}

}

void Sprite(int x0, int y0, int l, int h, register unsigned char *sprite)		{
	int x, y, a=0;
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr;

	ClipSprite;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			if (*sprite==0xfe)		{
				sprite+=3;
				ptr+=3;
				continue;
			}
			*ptr=*sprite++;
			ptr++;
			*ptr=*sprite++;
			ptr++;
			*ptr=*sprite++;
			ptr++;
		}
		sprite+=a;
	}

}

void TransSprite(int x0, int y0, int l, int h, register unsigned char *sprite, register unsigned char niveau)		{
	int x, y, a=0;
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr, nv=255-niveau;

	ClipSprite;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			if (*sprite==0xfe)		{
				sprite+=3;
				ptr+=3;
				continue;
			}
			*(ptr++)=((*ptr)*nv+niveau*(*sprite++))/255;
			*(ptr++)=((*ptr)*nv+niveau*(*sprite++))/255;
			*(ptr++)=((*ptr)*nv+niveau*(*sprite++))/255;
		}
		sprite+=a;
	}

}

void SpritePal(int x0, int y0, int l, int h, register unsigned char *sprite, unsigned char *palette)		{
	int x, y, a=0;
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr, *pal;

	ClipSprite;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			if (*sprite)
				pal=palette+3*(*sprite++);
			else	{
				sprite++;
				ptr+=3;
				continue;
			}
			*ptr=*pal++;
			ptr++;
			*ptr=*pal++;
			ptr++;
			*ptr=*pal++;
			ptr++;
		}
		sprite+=a;
	}

}

unsigned char *ChargeBmpDansSprite24(const char *nomFichier)		{
	FILE *f;
	unsigned char *ptr, *bloc;
	int i, x, y;
	WORD v;

	f=fopen(nomFichier,"rb");

	if (!f)		{
//		erreurFatale("Impossible de charger un des fichiers bitmap.");
		return NULL;
	}

	for (i=0;i<=26;i++)	{
		fread(&v,sizeof(WORD),1,f);		//Un mot, c'est deux octets

		if (i==9)  tx=v;
		if (i==11) ty=v;
	}

/*	if (tx>LARG || ty>HAUT)		{
		MessageBox(NULL,"L'en-tte de la bitmap est faux ou trop gros.","Oups...",MB_ICONERROR);
		return NULL;
	}*/

	bloc=(unsigned char *)malloc(tx*ty*3);

	for (y=ty-1;y>=0;y--)		{
		ptr=bloc+y*tx*3;
		for (x=0;x<tx*3;x++)		{
			*ptr++=fgetc(f);
		}
	}
	fclose(f);

	return bloc;
}

