//Test avec le raycaster de Nrx
#define LARG (240)
#define HAUT (160)
#include <wingraph.h>


#define DEPLACE_BUMP 6
#define ROTATION_VOX 4
#define ROTATION_RC  2
#define VERTICAL_RC  0.1*VIRGULE
#define XM4 240
#define YM4 200
#define XO4 (XM4/2)
#define YO4 (YM4/2)

#define XM5 240
#define YM5 160
#define XO5 (XM5/2)
#define YO5 (YM5/2)

#define PI       3.14159265
#define INVNB    1400
#define VIRGULE_ 12
#define VIRGULE  (1<<VIRGULE_)

// Variables globales publiques
volatile unsigned long* ecran;
signed short*            SINUS;
signed short*            INV;

#define XM (XM4)
#define YM (YM4)
#define XO (XM/2)
#define YO (YM/2)

#define HAUTEUR  (2*VIRGULE)
#define CARTE_   4
#define CARTE    (1<<CARTE_)
#define TEXTURE_ 3
#define TEXTURE  (1<<TEXTURE_)
#define VITESSE  0.06
#define DISTMIN  (0.3*VIRGULE)

#define XO     (XM/2)
#define YO     (YM/2)
#define COEFX_ 6
#define COEFY_ 6

unsigned char carte[CARTE*CARTE]={1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                                                1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
                                                1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
                                                1,0,0,0,0,0,0,0,0,3,3,3,0,0,0,1,
                                                1,0,0,0,0,0,0,0,0,3,3,3,0,0,0,1,
                                                1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,
                                                2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,1,
                                                2,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,
                                                2,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,
                                                2,2,0,2,2,2,2,0,0,0,0,1,0,0,0,1,
                                                2,0,0,0,0,0,2,2,2,0,0,1,0,2,0,1,
                                                2,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,
                                                2,0,0,3,0,0,3,0,0,3,0,0,0,0,0,1,
                                                2,0,0,0,0,0,0,0,0,0,0,1,0,2,0,1,
                                                2,0,0,0,0,0,2,2,2,0,0,1,0,0,0,1,
                                                2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1};

OBJET *balle;

void initCommun(void)
{
   signed short n;
   unsigned char A;

   // Reserve de la memoire pour notre tableau de sinus
   SINUS=(signed short*)malloc(256*sizeof(signed short));

   // Creation du tableau de sinus
   for(A=0;A<=64;++A)
   {
      n=sin(A*2*PI/256)*VIRGULE;
      SINUS[A]=n;
      SINUS[127-A]=n;
      SINUS[127+A]=-n;
      SINUS[255-A]=-n;
   }

   // Reserve de la memoire pour notre tableau d'inverses
   INV=(signed short*)malloc(INVNB*sizeof(signed short));

   // Creation du tableau d'inverses
   INV[0]=0;
   for(n=1;n<INVNB;++n)
      INV[n]=VIRGULE/n;
}

unsigned long texture[4][4]=		{
	{RGB(0,0,0),RGB(32,32,32),RGB(64,64,64),RGB(96,96,96)},
	{RGB(32,32,32),RGB(64,64,64),RGB(96,96,96),RGB(128,128,128)},
	{RGB(64,64,64),RGB(96,96,96),RGB(128,128,128),RGB(160,160,160)},
	{RGB(96,96,96),RGB(128,128,128),RGB(160,160,160),RGB(192,192,192)},
};

unsigned long textureSol[4][4]=		{
	{RGB(0,0,0),RGB(0,0,85),RGB(0,0,170),RGB(0,0,255)},
	{RGB(0,85,0),RGB(0,85,85),RGB(0,85,170),RGB(0,85,255)},
	{RGB(0,170,0),RGB(0,170,85),RGB(0,170,170),RGB(0,170,255)},
	{RGB(0,255,0),RGB(0,255,85),RGB(0,255,170),RGB(0,255,255)},
};

///////////////
// rayCaster //
///////////////
void rayCaster(signed long x,signed long y,signed long z,unsigned char A,unsigned char sol)
{
   signed long sin,cos;
   unsigned long K,X,Z;
   signed short dX[YO-1],dZ[YO-1],idX[YO-1],idZ[YO-1];
   signed long Vx,Vz,dVx,dVz,distv,disth,dist;
   signed long xv,xh,dx,zv,zh,dz;
   unsigned short xy_ecran,x_texture,y_texture,dy_texture;
   signed short xe,ymin,ymax;
   unsigned char ye,num_texture;

   // Retrouve le sinus & cosinus
   sin=SINUS[A];
   cos=SINUS[(unsigned char)(A+64)];

   // Preparation pour le mapping du sol
   if(sol)
   {
      ye=YO-1; // On va du bas (YM-1) jusqu'a l'horizon (YO+1), mais on fait un changement de repere (-YO)
      while(ye)
      {
         K=(y*INV[ye--])>>VIRGULE_;
         X=(K*cos)>>VIRGULE_;
         Z=(K*sin)>>VIRGULE_;
         dX[ye]=X;
         dZ[ye]=Z;
         idX[ye]=x+(Z-X)*XO;
         idZ[ye]=z+(Z+X)*XO;
      }
   }

   // Preparation pour le ray casting
   Vx=sin-cos;
   Vz=sin+cos;
   dVx=cos/XO;
   dVz=sin/XO;

   // Parcourt tout l'ecran
   for(xe=0;xe<XM;++xe)
   {
      // Intersections verticales
      distv=1<<30;
      xv=x&~(VIRGULE-1);
      zv=z;
      if(Vx)
      {
         if(Vx>0)
         {
            dx=VIRGULE;
            xv+=dx+8; // Ajout d'une constante pour corriger l'approximation qui laisse voir entre 2 murs (ok ?)
         }
         else
         {
            dx=-VIRGULE;
            --xv;
         }
         dz=(Vz<<VIRGULE_)/Vx;
         zv+=(dz*(xv-x))>>VIRGULE_;
         if(Vx<0)
            dz=-dz;

         while((unsigned long)zv<(CARTE<<VIRGULE_))
         {
            if(carte[(xv>>VIRGULE_)|((zv>>(VIRGULE_-CARTE_))&~(CARTE-1))])
            {
               distv=((xv-x)<<VIRGULE_)/Vx;
               break;
            }
            xv+=dx;
            zv+=dz;
         }
      }

      // Intersections horizontales
      disth=1<<30;
      zh=z&~(VIRGULE-1);
      xh=x;
      if(Vz)
      {
         if(Vz>0)
         {
            dz=VIRGULE;
            zh+=dz;
         }
         else
         {
            dz=-VIRGULE;
            --zh;
         }
         dx=(Vx<<VIRGULE_)/Vz;
         xh+=(dx*(zh-z))>>VIRGULE_;
         if(Vz<0)
            dx=-dx;

         while((unsigned long)xh<(CARTE<<VIRGULE_))
         {
            if(carte[(xh>>VIRGULE_)|((zh>>(VIRGULE_-CARTE_))&~(CARTE-1))])
            {
               disth=((zh-z)<<VIRGULE_)/Vz;
               break;
            }
            xh+=dx;
            zh+=dz;
         }
      }

      // Prend le mur le plus pres
      if(distv<disth)
      {
         dist=distv;
         num_texture=carte[(xv>>VIRGULE_)|((zv>>(VIRGULE_-CARTE_))&~(CARTE-1))];
         x_texture=(zv>>(VIRGULE_-TEXTURE_))&(TEXTURE-1);
      }
      else
      {
         dist=disth;
         num_texture=carte[(xh>>VIRGULE_)|((zh>>(VIRGULE_-CARTE_))&~(CARTE-1))];
         x_texture=(xh>>(VIRGULE_-TEXTURE_))&(TEXTURE-1);
      }

      // Pour la demo on se contente de 3 textures : rouge, verte et bleue...
      num_texture=5*num_texture-4;

      // Affiche le morceau de mur
      ymin=YO+((y-HAUTEUR)*XO)/dist;
      ymax=YO+(y*XO)/dist;
      dy_texture=dist/((XO*HAUTEUR)>>16); // On change la virgule fixe pour plus de precision...

      if(ymin<0)
      {
         y_texture=-ymin*dy_texture;
         ymin=0;
      }
      else
         y_texture=0;

      if(ymax>YM)
         ymax=YM;

      xy_ecran=xe;
      ye=0;

	  //Dessine le plafond
      while(ye<ymin)
      {
         ecran[xy_ecran]=RGB(64,64,64);
         xy_ecran+=XM5;
         ++ye;
      }
      while(ye<ymax)
      {
		 ecran[xy_ecran]=texture[(y_texture>>(16-TEXTURE_))%4][3-(x_texture%4)];
//		 ecran[xy_ecran]=x_texture+256*(y_texture>>(16-TEXTURE_));
//         ecran[xy_ecran]=(x_texture^(y_texture>>(16-TEXTURE_)))<<num_texture;
         xy_ecran+=XM5;
         y_texture+=dy_texture;
         ++ye;
      }

      // Mapping du sol
      if(sol)
      {
         ye-=YO;
         while(ye<YO-1)
         {
            X=idX[ye]+xe*dX[ye];
            Z=idZ[ye]-xe*dZ[ye];
//            ecran[xy_ecran]=RGB(0,0,255);
//            ecran[xy_ecran]=((X)>>(VIRGULE_-TEXTURE_))+256*((Z)>>(VIRGULE_-TEXTURE_));
			ecran[xy_ecran]=textureSol[((Z)>>(VIRGULE_-TEXTURE_+2))%4][((X)>>(VIRGULE_-TEXTURE_+2))%4];
            xy_ecran+=XM5;
            ++ye;
         }
      }
      else
         while(ye<YM)
         {
            ecran[xy_ecran]=RGB(180,180,180);
            xy_ecran+=XM5;
            ++ye;
         }

      // Rayon suivant !
      Vx+=dVx;
      Vz-=dVz;
   }
}


void rayCasterTrashed(signed long x,signed long y,signed long z,unsigned char A,unsigned char sol)
{
   signed long sin,cos;
   unsigned long K,X,Z;
   signed short dX[YO-1],dZ[YO-1],idX[YO-1],idZ[YO-1];
   signed long Vx,Vz,dVx,dVz,distv,disth,dist;
   signed long xv,xh,dx,zv,zh,dz;
   unsigned short xy_ecran,x_texture,y_texture,dy_texture;
   signed short xe,ymin,ymax;
   signed short ye,num_texture;
   register long i,j;

   // Retrouve le sinus & cosinus
   sin=SINUS[A];
   cos=SINUS[(unsigned char)(A+64)];

   // Preparation pour le mapping du sol
   if(sol)
   {
      ye=YO-1; // On va du bas (YM-1) jusqu'a l'horizon (YO+1), mais on fait un changement de repere (-YO)
      while(ye)
      {
         K=(y*INV[ye--])>>VIRGULE_;
         X=(K*cos)>>VIRGULE_;
         Z=(K*sin)>>VIRGULE_;
         dX[ye]=X;
         dZ[ye]=Z;
         idX[ye]=x+(Z-X)*XO;
         idZ[ye]=z+(Z+X)*XO;
      }
   }

   // Preparation pour le ray casting
   Vx=sin-cos;
   Vz=sin+cos;
   dVx=cos/XO;
   dVz=sin/XO; 

   // Parcourt tout l'ecran
   for(xe=0;xe<XM;++xe)
   {
      // Mapping du sol
	  xy_ecran=xe;
	  xy_ecran+=240*3*20;
	  ye=0;
     while(ye<YO-1)
     {
        X=idX[ye]+xe*dX[ye];
        Z=idZ[ye]-xe*dZ[ye];
//            ecran[xy_ecran]=RGB(0,0,255);
//            ecran[xy_ecran]=((X)>>(VIRGULE_-TEXTURE_))+256*((Z)>>(VIRGULE_-TEXTURE_));
		i=((X)>>(VIRGULE_-TEXTURE_+2));
		j=((Z)>>(VIRGULE_-TEXTURE_+2));
		ecran[xy_ecran]=textureSol[j%4][i%4];
        xy_ecran+=XM5;
        ++ye;
     }

      // Rayon suivant !
      Vx+=dVx;
      Vz-=dVz;
   }
}





///////////////////
// deplacementRC //
///////////////////
void deplacementRC(signed long* x,signed long* z,unsigned char A)
{
   signed long m,n;
   
   m=SINUS[A]*VITESSE;
   n=*x+m;
   if(m>0)
      m=DISTMIN;
   else
      m=-DISTMIN;
//   if(!carte[((n+m)>>VIRGULE_)|((*z>>(VIRGULE_-CARTE_))&~(CARTE-1))])
      *x=n;

   m=SINUS[(unsigned char)(A+64)]*VITESSE;
   n=*z+m;
   if(m>0)
      m=DISTMIN;
   else
      m=-DISTMIN;
//   if(!carte[(*x>>VIRGULE_)|(((n+m)>>(VIRGULE_-CARTE_))&~(CARTE-1))])
      *z=n;
}

void main()		{
	OBJET *salut;
	double j;
	int k;
	char chaine[1024];
	HPEN pen;
	HBRUSH brush;
	int i,xx,yy;
	signed long x,y,z,dx,dy;
	unsigned char A,ok,n,sol;
	unsigned long *ptr;

	balle=CreeObjetDeBmp24("balle.bmp");
	initCommun();
	ecran=malloc(240*160*4);

	A=32;
	n=0;
	sol=1;
	z=1.5*VIRGULE;
	x=1.5*VIRGULE;
	y=1.25*VIRGULE;

	ModeGraphique();

	InitTimer();
	while(1)		{
		if (!skip)		{
			EffaceEcran();
			balle->x=-16, balle->y=-16;
			rayCasterTrashed(x,y+(SINUS[n]>>3),z,A,sol);
			ptr=ecran;
			for (yy=0;yy<160;yy++)		{
				for (xx=0;xx<240;xx++)		{
					DessPix(xx,yy,*ptr++);
				}
			}
			Objet(balle);
			AfficheEcran();
		}
		AttendSync(20);
		// Deplacement
		if(testTouche(T_GAUCHE))
		 A-=ROTATION_RC;
		if(testTouche(T_DROITE))
		 A+=ROTATION_RC;
		if(testTouche(T_HAUT))
		 deplacementRC(&x,&z,A);
		if(testTouche(T_BAS))
		 deplacementRC(&x,&z,A+127);
		if(testTouche('C') && y>=0.3*VIRGULE)
		 y-=VERTICAL_RC;
		if(testTouche('E') && y<1.7*VIRGULE)
		 y+=VERTICAL_RC;
		if(testTouche('A'))
		 deplacementRC(&x,&z,A-64);
		if(testTouche('R'))
		 deplacementRC(&x,&z,A+64);
//		A+=0.001*VIRGULE;
	}

	ColoreCadre(0,0,LARG,HAUT,RGB(180,180,180));
	for (i=0;i<75;i++)		{
		k=175-7*i/3;
		pen=CreatePen(PS_SOLID,1,RGB(k,k,k));
		SelectObject(hdcImage,pen);
		brush=CreateSolidBrush(RGB(k,k,k));
		SelectObject(hdcImage,brush);
		Ellipse(hdcImage,102+i,80+i,180+112-i,180+90-i);
		DeleteObject(pen);
		DeleteObject(brush);
	}
	getch();

	printf("Bienvenue!\nVoici une dmo de rotation et d'agrandissement\n 2004 WinGraph pawaaa!\n");
	gets(chaine);
	balle=CreeObjetDeBmp24("canon.bmp");

	clrscr();
	DoubleBuffer=TRUE;
	InitTimer();
	AttenteASynchrone();
	i=0;
	j=0.0;
//	ZoneEcran(100,50,500,250);
	for (k=0;k<497;k++)		{
		j+=0.0001;
		i+=j;
		if (!skip)		{
			EffaceEcran();
//			Redimensionne(balle,LARG/2-(LARG*(int)i)/(2*HAUT),HAUT/2-(int)i/2,(LARG*(int)i)/HAUT,(int)i);
			Rotozoom(balle,LARG/2,HAUT/2,i,(double)(k*3.1416)/180);
//			SoustraitCadre(0,0,LARG,HAUT,RGB(192,0,192));
//			ObjetXY(i,0,balle);
//			Redimensionne(balle,100-k/2,150-3*k/10,balle->largeur*i,balle->hauteur*i);
			AfficheEcran();
		}
		AttendSync(10);
	}
	DoubleBuffer=FALSE;
	printf("Termin! :>");
	gets(chaine);
}
